#include "stdafx.h"
#include "lsapi.h"
#include "FileInformation.h"
#include "NotifyDirCheck.h"

#define _MERGE_RDATA_
#include "AggressiveOptimize.h"

/* The one and only exported functions */
extern "C"
{
__declspec( dllexport ) void OnStart(LPCSTR path1, LPCSTR path2);
__declspec( dllexport ) void OnStop();
}

CNotifyDirCheck m_desktop;
CNotifyDirCheck m_commondesktop;

UINT DirCallback( CFileInformation fiObject, EFileAction faAction, LPVOID lpData )
{
	CString filepath = fiObject.GetFilePath();
	CString Bang;

	if( IS_CREATE_FILE( faAction ) )
	{
		Bang = ("!labeldesktopcreate updateadd \"" + filepath + "\"");
		LSExecute(NULL, Bang, SW_SHOWNORMAL);
	}
	else if( IS_DELETE_FILE( faAction ) )
	{
		Bang = ("!labeldesktopcreate updatedel \"" + filepath + "\"");
		LSExecute(NULL, Bang, SW_SHOWNORMAL);
	}
	else if( IS_CHANGE_FILE( faAction ) )
	{
		Bang = ("!labeldesktopcreate updateren \"" + filepath + "\"");
		LSExecute(NULL, Bang, SW_SHOWNORMAL);
	}
	else
	{
		return 1; //error, stop thread
	}

	return 0; //success
}

void OnStart(LPCSTR path1, LPCSTR path2) 
{
	m_desktop.SetDirectory( path1 );
	m_commondesktop.SetDirectory( path2 );

	//set your callback to work with each new event
	m_desktop.SetActionCallback( DirCallback );
	m_commondesktop.SetActionCallback( DirCallback );
	
	m_desktop.Run();
	m_commondesktop.Run();
}

void OnStop() 
{
	m_desktop.Stop();
	m_commondesktop.Stop();
}


